<template>
  <div class="user">
    <div class="tree">
      <treeList
        title="产品分类"
        submitType="1"
        :data="treeListData"
        v-model="sourceList.pagination.productClassifyId"
        @change="treeChange"
        @changeTreeList="getTreeList"
      >
      </treeList>
    </div>
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          props.selectStatus
            ? {}
            : {
                text: 'Excel导入',
                action: () => openExcel(),
                disabled: false,
              },
          props.selectStatus
            ? {}
            : {
                text: '添加',
                action: () => openModal('add'),
                disabled: false,
              },
        ]"
        @get-list="getList"
      >
        <template #pic="{ item }">
          <div v-if="item.fileList.length > 0">
            <img
              :src="item.fileList[0].fileUrl"
              class="pic"
              @click="handleClickFile(item.fileList[0])"
            />
          </div>
          <div v-else></div>
        </template>
        <template #size="{ item }">
          <div>
            <span>{{ item.productLong }}cm</span>*
            <span>{{ item.productWide }}cm</span>*
            <span>{{ item.productHigh }}cm</span>
          </div>
        </template>
        <template #price="{ item }">
          <div>
            <span v-if="item.price">${{ item.price }}</span>
          </div>
        </template>
        <template #costPrice="{ item }">
          <div>
            <span v-if="item.costPrice">¥{{ item.costPrice }}</span>
          </div>
        </template>
      </byTable>
    </div>

    <el-dialog
      :title="modalType == 'add' ? '添加产品' : '编辑产品'"
      v-model="dialogVisible"
      width="600"
      v-loading="submitLoading"
      destroy-on-close
    >
      <div class="public_height_dialog">
        <byForm
          :formConfig="formConfig"
          :formOption="formOption"
          v-model="formData.data"
          :rules="rules"
          ref="byform"
        >
          <template #productPic>
            <div>
              <el-upload
                v-model:fileList="fileList"
                action="https://winfaster.obs.cn-south-1.myhuaweicloud.com"
                :data="uploadData"
                list-type="picture-card"
                :on-remove="handleRemove"
                :before-upload="handleBeforeUpload"
                accept=".gif, .jpeg, .jpg, .png"
              >
                <el-icon><Plus /></el-icon>
              </el-upload>
            </div>
          </template>
        </byForm>
      </div>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
          >确 定</el-button
        >
      </template>
    </el-dialog>

    <el-dialog
      title="导入产品"
      v-model="openExcelDialog"
      width="400"
      v-loading="excelLoading"
    >
      <el-upload
        :action="actionUrl + '/productInfo/excelImportByEhsd'"
        :headers="headers"
        :on-success="handleSuccess"
        :on-progress="handleProgress"
        :show-file-list="false"
        :on-error="handleError"
        accept=".xlsx"
      >
        <el-button type="primary">点击导入</el-button>
      </el-upload>
      <template #footer>
        <el-button @click="openExcelDialog = false" size="large"
          >取 消</el-button
        >
      </template>
    </el-dialog>
  </div>
</template>

<script setup>
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import treeList from "@/components/product/treeList";
import { getToken } from "@/utils/auth";

const headers = ref({ Authorization: "Bearer " + getToken() });
const actionUrl = import.meta.env.VITE_APP_BASE_API;
const loading = ref(false);
const submitLoading = ref(false);
const treeListData = ref([]);
const innerMethon = ref([]);
const outsideMethon = ref([]);
const productUnit = ref([]);
const accountCurrency = ref([]);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
    type: "",
    productClassifyId: "",
    keyword: "",
    definition: "1",
  },
});
let dialogVisible = ref(false);
let openExcelDialog = ref(false);
let excelLoading = ref(false);
let modalType = ref("add");
let rules = ref({
  productClassifyId: [
    { required: true, message: "请选择产品分类", trigger: "change" },
  ],
  name: [{ required: true, message: "请输入产品名称", trigger: "blur" }],
  unit: [{ required: true, message: "请选择产品单位", trigger: "change" }],
  productLong: [
    { required: true, message: "请输入长 （cm）", trigger: "blur" },
  ],
  productWide: [
    { required: true, message: "请输入宽 （cm）", trigger: "blur" },
  ],
  productHigh: [
    { required: true, message: "请输入高 （cm）", trigger: "blur" },
  ],
  innerPackMethod: [
    { required: true, message: "请选择内包装方式", trigger: "change" },
  ],
  outerPackMethod: [
    { required: true, message: "请选择外包装方式", trigger: "change" },
  ],
});
const { proxy } = getCurrentInstance();
const props = defineProps({
  selectStatus: Boolean,
});
const selectConfig = reactive([
  // {
  //   label: "产品类型",
  //   prop: "type",
  //   data: [],
  // },
]);
const config = computed(() => {
  return [
    {
      attrs: {
        label: "图片",
        slot: "pic",
        align: "center",
        width: 100,
      },
    },
    {
      attrs: {
        label: "产品编码",
        prop: "code",
      },
    },
    {
      attrs: {
        label: "产品名称",
        prop: "name",
      },
    },
    {
      attrs: {
        label: "单位",
        prop: "unit",
      },
      render(unit) {
        return proxy.dictValueLabel(unit, productUnit.value);
      },
    },
    {
      attrs: {
        label: "尺寸",
        slot: "size",
      },
    },
    {
      attrs: {
        label: "销售指导价",
        slot: "price",
        width: 150,
      },
    },
    {
      attrs: {
        label: "成本价",
        slot: "costPrice",
        width: 150,
      },
    },
    {
      attrs: {
        label: "操作",
        width: "120",
        align: "center",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          props.selectStatus
            ? {
                attrs: {
                  label: "选择",
                  type: "primary",
                  text: true,
                },
                el: "button",
                click() {
                  clickSelect(row);
                },
              }
            : {
                attrs: {
                  label: "修改",
                  type: "primary",
                  text: true,
                },
                el: "button",
                click() {
                  getDtl(row);
                },
              },
          props.selectStatus
            ? {}
            : {
                attrs: {
                  label: "删除",
                  type: "danger",
                  text: true,
                },
                el: "button",
                click() {
                  // 弹窗提示是否删除
                  ElMessageBox.confirm(
                    "此操作将永久删除该数据, 是否继续?",
                    "提示",
                    {
                      confirmButtonText: "确定",
                      cancelButtonText: "取消",
                      type: "warning",
                    }
                  ).then(() => {
                    // 删除
                    proxy
                      .post("/productInfo/delete", {
                        id: row.id,
                      })
                      .then((res) => {
                        ElMessage({
                          message: "删除成功",
                          type: "success",
                        });
                        getList();
                      });
                  });
                },
              },
        ];
      },
    },
  ];
});

const uploadData = ref({});
const fileList = ref([]);
const fileListCopy = ref([]);
let formData = reactive({
  data: {},
});
const formOption = reactive({
  disabled: false,
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const formConfig = computed(() => {
  return [
    {
      type: "title",
      title: "基本信息",
    },
    {
      type: "treeSelect",
      prop: "productClassifyId",
      label: "产品分类",
      data: treeListData.value,
      itemWidth: 100,
      disabled: false,
      style: {
        width: "100%",
      },
    },
    {
      type: "input",
      prop: "name",
      label: "产品名称",
      itemWidth: 100,
      disabled: false,
    },
    {
      type: "input",
      prop: "nameEnglish",
      label: "英文名",
      itemWidth: 100,
      disabled: false,
    },
    {
      type: "select",
      prop: "unit",
      label: "单位",
      required: true,
      itemWidth: 100,
      data: productUnit.value,
      style: {
        width: "50%",
      },
      disabled: false,
    },
    {
      type: "slot",
      slotName: "productPic",
      prop: "fileList",
      label: "产品图片",
    },
    {
      type: "title",
      title: "价格信息",
    },
    {
      type: "selectInput",
      prop: "price",
      selectProp: "currency",
      label: "销售指导价",
      itemWidth: 50,
      style: {
        width: "100%",
      },
      data: accountCurrency.value,
    },
    {
      type: "selectInput",
      prop: "costPrice",
      selectProp: "currencyOne",
      label: "成本价",
      itemWidth: 50,
      style: {
        width: "100%",
      },
      data: accountCurrency.value,
    },
    {
      type: "title",
      title: "属性信息",
    },
    {
      type: "input",
      prop: "spec",
      label: "规格型号",
      itemWidth: 100,
      disabled: false,
    },
    {
      type: "input",
      prop: "productLong",
      label: "尺寸",
      itemWidth: 33.33,
      placeholder: "长（cm）",
      disabled: false,
    },
    {
      type: "input",
      prop: "productWide",
      label: " ",
      itemWidth: 33.33,
      placeholder: "宽（cm）",
      disabled: false,
    },
    {
      type: "input",
      prop: "productHigh",
      label: " ",
      itemWidth: 33.33,
      placeholder: "高（cm）",
      disabled: false,
    },
    {
      type: "select",
      prop: "innerPackMethod",
      label: "内包装方式",
      required: true,
      itemWidth: 50,
      multiple: true,
      data: innerMethon.value,
      placeholder: "内包装方式",
      style: {
        width: "100%",
      },
      disabled: false,
    },
    {
      type: "select",
      prop: "outerPackMethod",
      label: "外包装方式",
      required: true,
      itemWidth: 50,
      multiple: true,
      data: outsideMethon.value,
      placeholder: "外包装方式",
      style: {
        width: "100%",
      },
      disabled: false,
    },
    {
      type: "input",
      prop: "netWeight",
      label: "净重（kg）",
      itemWidth: 100,
      style: {
        width: "30%",
      },
    },
    {
      type: "input",
      prop: "hsCode",
      label: "海关编码",
      itemWidth: 100,
      style: {
        width: "30%",
      },
      disabled: false,
    },
    {
      type: "input",
      itemType: "textarea",
      prop: "remark",
      label: "备注",
      itemWidth: 100,
    },
  ];
});

const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/productInfo/getConditionProductList", sourceList.value.pagination)
    .then(
      (message) => {
        sourceList.value.data = message.rows.map((x) => ({
          ...x,
          fileList: [],
          ...JSON.parse(x.ehsdJson),
        }));
        sourceList.value.pagination.total = message.total;
        setTimeout(() => {
          loading.value = false;
        }, 200);
        const productIdList = message.rows.map((x) => x.id);
        // 请求文件数据并回显
        if (productIdList.length > 0) {
          proxy
            .post("/fileInfo/getList", {
              businessIdList: productIdList,
            })
            .then((fileObj) => {
              for (let i = 0; i < sourceList.value.data.length; i++) {
                const e = sourceList.value.data[i];
                for (const key in fileObj) {
                  if (e.id === key) {
                    e.fileList = fileObj[key];
                  }
                }
              }
            });
        }
      },
      (err) => {
        loading.value = false;
      }
    );
};

const treeChange = (e) => {
  sourceList.value.pagination.productClassifyId = e.id;
  getList({ productClassifyId: e.id });
};

const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {
    definition: "1",
    outerPackMethod: [],
    innerPackMethod: [],
    fileList: [],
    fileListCopy: [],
    currency: "$",
    currencyOne: "¥",
  };
  fileList.value = [];
  fileListCopy.value = [];
};

const openExcel = () => {
  openExcelDialog.value = true;
};

const needAtt = [
  "productClassifyId",
  "name",
  "spec",
  "remark",
  "fileList",
  "id",
  "unit",
  "definition",
];
let jsonObj = {};
const submitForm = () => {
  byform.value.handleSubmit((valid) => {
    // if (!fileListCopy.value.length > 0) {
    //   return ElMessage({
    //     message: "请上传产品图片",
    //     type: "info",
    //   });
    // }
    formData.data.fileList = fileListCopy.value.map((x) => ({
      id: x.id,
      fileName: x.fileName,
    }));
    for (const key in formData.data) {
      if (needAtt.includes(key)) {
      } else {
        jsonObj[key] = formData.data[key];
        delete formData.data[key];
      }
    }
    jsonObj.innerPackMethod = jsonObj.innerPackMethod.join(",");
    jsonObj.outerPackMethod = jsonObj.outerPackMethod.join(",");
    jsonObj.type = "1"; //1为公司产品库
    formData.data.ehsdJson = JSON.stringify(jsonObj);
    submitLoading.value = true;
    proxy.post(`/productInfo/${modalType.value}ByEhsd`, formData.data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => {
        for (const key in jsonObj) {
          formData.data[key] = jsonObj[key];
        }
        formData.data.innerPackMethod =
          formData.data.innerPackMethod.split(",");
        formData.data.outerPackMethod =
          formData.data.outerPackMethod.split(",");
        submitLoading.value = false;
      }
    );
  });
};
const getTreeList = () => {
  proxy
    .post("/productClassify/tree", { parentId: "", name: "", definition: "1" })
    .then((message) => {
      treeListData.value = message;
    });
};
const getDtl = (row) => {
  modalType.value = "edit";
  proxy.post("/productInfo/detailByEhsd", { id: row.id }).then((res) => {
    res.definition = "1"; //产品
    res = {
      ...res,
      currency: "$",
      currencyOne: "¥",
      ...JSON.parse(res.ehsdJson),
    };
    if (res.innerPackMethod) {
      res.innerPackMethod = res.innerPackMethod.split(",");
    } else {
      res.innerPackMethod = [];
    }
    if (res.outerPackMethod) {
      res.outerPackMethod = res.outerPackMethod.split(",");
    } else {
      res.outerPackMethod = [];
    }
    formData.data = res;
    dialogVisible.value = true;
    proxy
      .post("/fileInfo/getList", { businessIdList: [row.id] })
      .then((fileObj) => {
        if (fileObj[row.id]) {
          fileList.value = fileObj[row.id].map((x) => ({
            ...x,
            url: x.fileUrl,
          }));
          fileListCopy.value = fileObj[row.id].map((x) => ({
            ...x,
            url: x.fileUrl,
          }));
        } else {
          fileList.value = [];
          fileListCopy.value = [];
        }
      });
  });
};
const isdisabled = ["price", "costPrice", "remark", "netWeight"];
watch(modalType, (val) => {
  if (val) {
    for (let i = 0; i < formConfig.value.length; i++) {
      const element = formConfig.value[i];
      if (element.type != "title" || element.type != "slot") {
        if (!isdisabled.includes(element.prop)) {
          element.disabled = val == "edit" ? true : false;
        }
      }
    }
  }
});
const handleBeforeUpload = async (file) => {
  const res = await proxy.post("/fileInfo/getSing", { fileName: file.name });
  uploadData.value = res.uploadBody;
  fileListCopy.value.push({
    id: res.id,
    fileName: res.fileName,
    path: res.fileUrl,
    url: res.fileUrl,
    uid: file.uid,
  });
};
const handleRemove = (file) => {
  const index = fileListCopy.value.findIndex(
    (x) => x.uid === file.uid || x.id === file.id
  );
  fileListCopy.value.splice(index, 1);
};
const handleClickFile = (file) => {
  window.open(file.fileUrl, "_blank");
};
const handleProgress = () => {
  excelLoading.value = true;
};
const handleError = (err) => {
  console.log(res);
  ElMessage({
    message: `${err}，请重试！`,
    type: "info",
  });
  openExcelDialog.value = false;
  excelLoading.value = false;
};
const handleSuccess = (res) => {
  if (res.code != 200) {
    return ElMessage({
      message: `${res.msg}，请重试！`,
      type: "info",
    });
  } else {
    ElMessage({
      message: "导入成功！",
      type: "success",
    });
    openExcelDialog.value = false;
    excelLoading.value = false;
    getList();
  }
};
const getDict = () => {
  proxy
    .getDictOne([
      "inner_packaging_method_ehsd",
      "outside_packaging_method_ehsd",
      "unit",
      "account_currency",
    ])
    .then((res) => {
      innerMethon.value = res["inner_packaging_method_ehsd"].map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
      outsideMethon.value = res["outside_packaging_method_ehsd"].map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
      productUnit.value = res["unit"].map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
      accountCurrency.value = res["account_currency"].map((x) => ({
        label: x.dictKey,
        value: x.dictValue,
      }));
    });
};
getDict();
getTreeList();
getList();
const clickSelect = (item) => {
  proxy.$emit("selectProduct", item);
};
</script>

<style lang="scss" scoped>
.user {
  padding: 20px;
  display: flex;
  justify-content: space-between;
  .tree {
    width: 300px;
  }
  .content {
    width: calc(100% - 320px);
  }
}
.pic {
  object-fit: contain;
  width: 50px;
  height: 50px;
  cursor: pointer;
  vertical-align: middle;
}
</style>
